# Luakit Documentation / Modules / soup

# Module `soup`

URI parsing utilities
This module is only available from the UI process Lua state.

The soup API provides some utilities for parsing and converting URIs, written in C. For historical reasons, it also provides some other miscellaneous APIs.

## Functions

### soup.parse_uri (uri)

Parse a URI.

#### Parameters

- uri
  Type: string
  The URI to parse.

#### Return Values

- table
  A table of URI components.

### soup.uri_tostring (uri)

Convert a table of URI components to a string.

#### Parameters

- uri
  Type: table
  A table of URI components.

#### Return Values

- string
  The URI string.

## Properties

### soup.proxy_uri

Type: string
Default: `"default"`
Read-write
The URI of the proxy to use for connections. Can be a URI, the string `"no_proxy"`, the string `"default"`, or `nil` (which means the same as `"default"`).

### soup.accept_policy

Type: string
Default: `"no_third_party"`
Read-write
The cookie acceptance policy. Determines which cookies are accepted and stored. Can be one of `"always"`, `"never"`, and `"no_third_party"`.

### soup.cookies_storage

Type: string
Default: `nil`
Read-write
The path to the cookie database to use. Should only be set once. Initially unset, meaning no cookie database will be used.

## Attribution

#### Copyright

- 2012 Mason Larobina